/*=============================================
재정패널 만들기 : smart_nastab_v2 명령어 
2019-05-25:  add variables (가구원)  
==============================================*/
	program define smart_nastab_add_p_v2  , rclass 
	version 14.0 
	clear 
	set more off
    syntax newvarlist(min=1 max=200 numeric generate)  , [wd(string) website(string)] wave(string) 
	qui cd "`wd'" 
	local v1 "`wave'" 
	return scalar NW=wordcount("`v1'") 
	local NV=wordcount("`varlist'")
	return scalar NV=`NV'	
	
/*================================================================================*/
* addtype: p
/*================================================================================*/			
				qui foreach v of local v1   {						
					if "`website'"=="" {
						use NaSTaB`v'P, clear						
					}					
					else {					
						use `website'/NaSTaB`v'P, clear				
					}					
						 
						 local add_pplist ""
						 forvalues i=1/`NV' {
							local a1=substr("``i''",1,1)  
							local a2=substr("``i''",2,.)
								
								if regexm("``i''","p_")  {
										local a1=substr("``i''",1,2)   
										local a2=substr("``i''",3,.)
								}
								else if regexm("``i''","ps") {
										local a1=substr("``i''",1,2)  
										local a2=substr("``i''",3,.)
								}
							
							local a3="`a1'"+"`v'"+"`a2'"
							local a4=substr("``i''",1,2) 
									/*
									if  "`a4'"=="np" {
											local a1=substr("``i''",1,2)  // np로 시작하는 변수인 경우 
											local a2=substr("``i''",3,.)
											local a3="`a1'"+"`v'"+"`a2'"											
									}
									*/
						local add_pplist `add_pplist' `a3'						 
						 } // forvalues loop
									
						rename hid`v' hhid
						drop if hhid==. 
						label var hhid "가구id"
						rename pid`v' pid
						drop if pid==. 
						label var pid "가구원id"
						
						* 2016-11-27에 수정한 부분 
							qui ds
							foreach kk of local add_pplist {
								if regexm(r(varlist), "`kk'")==0 {
									gen `kk'=.
								}
							}	
						
						keep hhid pid `add_pplist'
						gen wave="`v'"
						gen wave1=real(wave)
						drop wave
						rename wave1 wave
						capture ren p_`v'_* p__*
						capture ren ps`v'* ps*
						capture ren p`v'* p*
						capture ren np`v'* np*  // ??
						tempfile nastab`v'_add_p_1 
						save "`nastab`v'_add_p_1'", replace 					
													
				}  // v1 loop  (wave loop) 
				
					qui if r(NW)==1 {
					  foreach v of local v1   {
					  use "`nastab`v'_add_p_1'", clear
                      tsset pid wave 
					  capture drop __*
					  compress
					  format hhid pid %15.0g
					  order hhid pid wave 
					  drop if pid==.
					  save nastab_add_p, replace		 
					  }
					}
				
					qui else {
						 local v2=substr("`v1'", 1,2) 
						 use "`nastab`v2'_add_p_1'", clear  
						 local v3=substr("`v1'",4, .)
						 foreach v of local v3  {
							append using "`nastab`v'_add_p_1'" , force 
						 }
						order hhid pid wave
						tsset pid wave 	
						aorder 
						order hhid pid wave 
						format hhid pid %15.0g
						capture drop __*
						compress
						drop if pid==.
						save nastab_add_p, replace 		     
									 
				}
			
end

